#ifndef __ROOT_HPP__
#define __ROOT_HPP__

#include <coroutine>


namespace typon
{

  struct root
  {
    struct promise_type;

    std::coroutine_handle<promise_type> _coroutine;

    struct promise_type
    {

      root get_return_object() noexcept
      {
        return { std::coroutine_handle<promise_type>::from_promise(*this) };
      }

      std::suspend_never initial_suspend() noexcept
      {
        return {};
      }

      std::suspend_never final_suspend() noexcept
      {
        return {};
      }

      void return_void() noexcept {}

      void unhandled_exception() noexcept {}
    };
  };

}

#endif // __ROOT_HPP__
